/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package EmployeeManagement;

import Service.EmployeeService;
import java.awt.Dimension;
import java.awt.Font;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.table.AbstractTableModel;
import model.Employee;

/**
 *
 * @author ASUS
 */
public class EmployeePanel extends javax.swing.JPanel {

    private final EmployeeService empService;
    private final List<Employee> empList;

    /**
     * Creates new form EmployeePanel
     */
    public EmployeePanel() {
        initComponents();
         UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.PLAIN, 14));
         
        empService = new EmployeeService();
        empList = empService.getEmployees();
        System.out.println(empList);
        
       TableEmp.setModel(new AbstractTableModel() {
            String[] columnNames = {"ID", "name", "Surname", "Tel","User","position",
                "gender","date of birth","nationality","religion","status","address"};

            @Override
            public String getColumnName(int column) {
                return columnNames[column];
            }

            @Override
            public int getRowCount() {
                return empList.size();
            }

            @Override
            public int getColumnCount() {
                return 11;
            }

            @Override
            public Object getValueAt(int rowIndex, int columnIndex) {
                Employee emp = empList.get(rowIndex);
                switch (columnIndex) {
                    case 0:
                        return emp.getEmpId();
                    case 1:
                        return emp.getEmpName();
                    case 2:
                        return emp.getEmpSurname();
                    case 3:
                        return emp.getEmpTel();
                    case 4:
                        return emp.getEmpUser();
                       case 5:
                        return emp.getEmpPosition();
                       case 6:
                           return emp.getEmpGender();
                       case 7:
                           return emp.getEmpDob();
                       case 8: 
                           return emp.getEmpNat();
                       case 9:
                           return emp.getEmpReligion();
                       case 10: 
                           return emp.getEmpStatus();
                           case 11:
                           return emp.getEmpStatus();
                    default:
                        return "Unknowm";
                }
            }
        });
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToggleButton1 = new javax.swing.JToggleButton();
        jPanel5 = new javax.swing.JPanel();
        textSearch = new javax.swing.JTextField();
        btnAddEmployee1 = new javax.swing.JButton();
        btnSearch = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        TableEmp = new javax.swing.JTable();

        jToggleButton1.setText("jToggleButton1");

        textSearch.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        textSearch.setForeground(new java.awt.Color(153, 153, 153));
        textSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textSearchActionPerformed(evt);
            }
        });

        btnAddEmployee1.setBackground(new java.awt.Color(84, 70, 63));
        btnAddEmployee1.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        btnAddEmployee1.setForeground(new java.awt.Color(255, 255, 255));
        btnAddEmployee1.setText("เพิ่มพนักงาน");
        btnAddEmployee1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddEmployee1ActionPerformed(evt);
            }
        });

        btnSearch.setBackground(new java.awt.Color(84, 70, 63));
        btnSearch.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        btnSearch.setForeground(new java.awt.Color(255, 255, 255));
        btnSearch.setText("ค้นหา");
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        TableEmp.setAutoCreateRowSorter(true);
        TableEmp.setBackground(new java.awt.Color(211, 197, 186));
        TableEmp.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        TableEmp.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4", "Title 5", "Title 6", "Title 7", "Title 8", "Title 9", "Title 10", "Title 11"
            }
        ));
        TableEmp.setRowHeight(40);
        TableEmp.setShowGrid(true);
        jScrollPane4.setViewportView(TableEmp);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addGap(17, 17, 17)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 921, Short.MAX_VALUE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(textSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 260, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btnSearch)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnAddEmployee1)))
                .addGap(15, 15, 15))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(7, 7, 7)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(1, 1, 1)
                        .addComponent(textSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnAddEmployee1, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(3, 3, 3))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(5, 5, 5))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
        if (textSearch.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "ข้อมูลไม่ถูกต้อง กรุณาลองใหม่อีกครั้ง");
        } else {
            Employee employee =empService.getEmployeeID(Integer.valueOf(textSearch.getText()));
            JOptionPane.showMessageDialog(null,"ข้อมูลของพนักงาน\n" + employee);
            textSearch.setText("");
        }
    }//GEN-LAST:event_btnSearchActionPerformed

    private void textSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textSearchActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_textSearchActionPerformed

    private void btnAddEmployee1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddEmployee1ActionPerformed
      AddEmployeeFrame viewAddEmp = new AddEmployeeFrame();
        viewAddEmp.setVisible(true);
    }//GEN-LAST:event_btnAddEmployee1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable TableEmp;
    private javax.swing.JButton btnAddEmployee1;
    private javax.swing.JButton btnSearch;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JTextField textSearch;
    // End of variables declaration//GEN-END:variables
}
